unit IniEdit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Dialogs, Menus, ValEdit,
  StdCtrls, IniFiles;

type

  { TFrmIniEdit }

  TFrmIniEdit = class(TForm)
    Memo1: TMemo;
    MenIniEdit: TMainMenu;
    MenIt_IniFile: TMenuItem;
    MenIt_Save: TMenuItem;
    MenIt_SaveNClose: TMenuItem;
    MenIt_Close: TMenuItem;
    MenIt_NewKey: TMenuItem;
    MenItIniNew: TMenuItem;
    ValEdIni: TValueListEditor;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure SaveINI;
    procedure MenItIniNewClick(Sender: TObject);
    procedure MenIt_NewKeyClick(Sender: TObject);
    procedure MenIt_CloseClick(Sender: TObject);
    procedure MenIt_SaveClick(Sender: TObject);
    procedure MenIt_SaveNCloseClick(Sender: TObject);
    function ChkIniExist:Boolean;
  private
    { private declarations }
  protected
  public
    { public declarations }
    procedure MakeIniFile;
  end;

var
  FrmIniEdit: TFrmIniEdit;

  {$IFDEF MSWINDOWS}
  const ext = '.ini';
  {$ENDIF}{$IFDEF UNIX}
  const ext = '.conf';
  {$ENDIF}


implementation

uses Main;

{$R *.lfm}

{ TFrmIniEdit }

procedure TFrmIniEdit.FormShow(Sender: TObject);
begin
  //ShowMessage('FrmIniEdit.FormShow');
  if ChkIniExist=False then MakeIniFile;
  ValEdIni.Strings.Clear;
  //Werte in ValueEditor aus Ini-Datei einlesen
  ValEdIni.Strings.LoadFromFile(IniPfad+'ORC'+ext);
end;

procedure TFrmIniEdit.MenItIniNewClick(Sender: TObject);
begin
  //ShowMessage('FrmIniEdit.MenItIniNewClick');
  MakeIniFile;
  IniF.WriteInteger('FrmIniEditPos','Left',Left);
  IniF.WriteInteger('FrmIniEditPos','Top',Top);
  IniF.UpdateFile;
end;

procedure TFrmIniEdit.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  IniF.WriteInteger('FrmIniEditPos','Left',Left);
  IniF.WriteInteger('FrmIniEditPos','Top',Top);
  IniF.UpdateFile;
  FrmMain.Show;
end;

procedure TFrmIniEdit.MenIt_NewKeyClick(Sender: TObject);
var
  NewKey,NewVal:String;
begin
  NewKey:=InputBox('Neuer Schlüssel','Bitte Name des neuen Schlüssels '+
  'eingeben','');
  NewVal:=InputBox('Neuer Wert','Bitte den Wert für den neuen Schlüssel '+
  'eingeben','');
  if (NewKey='') then Exit
  else ValEdIni.InsertRow(NewKey,NewVal,True);
end;

procedure TFrmIniEdit.MenIt_CloseClick(Sender: TObject);
begin
  FrmMain.Show;
  Close;
end;

procedure TFrmIniEdit.SaveINI;
var
  strBuff,strTMP:TStringList;
  strSection,strKey,strVal: String;
  i,iKeyLen:Integer;

begin
  //ShowMessage('FrmIniEdit.SaveINI');
  strBuff:=TStringList.Create;
  strTMP:=TStringList.Create;
  try
    //if (IniPfad='') then IniPfad:=ExtractFilePath(Application.ExeName);
    strBuff.AddStrings(ValEdIni.Strings);
    for i:=0 To strBuff.Count-1 do begin
      //ShowMessage(strBuff.Strings[i]);
      if Pos('[',strBuff.Strings[i])<>0 then begin  //wenn Section...
        strSection:=Copy(strBuff.Strings[i],Pos('[',strBuff.Strings[i])+1,
        Pos(']',strBuff.Strings[i])-2);
        //ShowMessage(strSection);
      end else
      begin          //wenn normaler Text...
        iKeyLen:=Pos('=',strBuff.Strings[i])-1;
        strKey:=Copy(strBuff.Strings[i],1,iKeyLen);
        strVal:=Copy(strBuff.Strings[i],iKeyLen+2,Length(strBuff.Strings[i])
        -iKeyLen+2);
      end;
      strTMP.Add('['+strSection+']: '+strKey+'='+strVal);
      //strTMP.Add('['+strSection+']: '+strKey+'='+strVal);
      IniF.WriteString(StrSection,strKey,StrVal);
      IniF.UpdateFile;
    end;
    Memo1.Text:=strTMP.Text;
    //StrBuff.Strings[0]:=StringReplace(StrBuff.Strings[0],'=','',[rfReplaceAll]);
    //StrBuff.SaveToFile(IniPfad+'ORC'+ext);   //TIniFile
    //StrBuff.SaveToStream(IniF.Stream);       //TMemIniFile
  finally
    strBuff.Free;
    strTMP.Free;
  end;
end;

procedure TFrmIniEdit.MenIt_SaveClick(Sender: TObject);
begin
  SaveINI;
end;

procedure TFrmIniEdit.MenIt_SaveNCloseClick(Sender: TObject);
begin
  SaveINI;
  Close;
end;

function TFrmIniEdit.ChkIniExist:Boolean;
// Prüft, ob INI/CONF-Datei vorhanden ist
begin
  //ShowMessage('FrmIniEdit.ChkIniExist');
  // Prüfen, ob 'ini/conf' Datei existiert
  if (IniPfad='') then IniPfad:=ExtractFilePath(Application.ExeName);
  if FileExists(IniPfad+'ORC'+ext) then Result:=True
  else Result:=False;
end;

procedure TFrmIniEdit.MakeIniFile;
// INI-Datei erstellen
var
  SL:TStringList;
  i:Integer;
begin
  //ShowMessage('FrmIniEdit.MakeIniFile');
  SL:=TStringList.Create;
  try
    //zuerst alten Inhalt löschen
    IniF.ReadSections(SL);
    for i:=0 To SL.Count-1 do IniF.EraseSection(SL[i]);
  finally
    SL.Free;
  end;
  try
    //Ini-Datei neu erstellen
    //ShowMessage(GetAppConfigDirUTF8(FALSE)+'ORC'+ext);
    IniF.WriteString('RISIKO','Multiple WK-Fx','2');
    IniF.WriteString('RISIKO','Oberschenkel-Fx','2');
    IniF.WriteString('RISIKO','Kortison High','2');
    IniF.WriteString('RISIKO','Kortison Mini','1');
    IniF.WriteString('RISIKO','Kortison Inhalation','0,5');
    IniF.WriteString('RISIKO','Diabetes Typ1','1');
    IniF.WriteString('RISIKO','Diabetes Typ2','0,5');
    IniF.WriteString('RISIKO','Rauchen','0,5');
    IniF.WriteString('RISIKO','COPD','0,5');
    IniF.WriteString('RISIKO','Stuerze','0,5');
    IniF.WriteString('RISIKO','Spondylitis Ankylopoetica','0,5');
    IniF.WriteString('RISIKO','Primaerer HPT','0,5');
    IniF.WriteString('RISIKO','Hyperkortisolismus','0,5');
    IniF.WriteString('RISIKO','Femur-Fx Eltern','0,5');
    IniF.WriteString('RISIKO','Hohes hsCRP','0,5');
    IniF.WriteString('RISIKO','STH Low','0,5');
    IniF.WriteString('RISIKO','Periphere Fx ab 50. LJ','0,5');
    IniF.WriteString('RISIKO','Singulaere WK-Fx','0,5');
    IniF.WriteString('RISIKO','Hohe Umbauparameter','0,5');
    IniF.WriteString('RISIKO','Immobilitaet','0,5');
    IniF.WriteString('RISIKO','Z. n. Magen-OP','0,5');
    IniF.WriteString('RISIKO','Herzinsuffizienz','0,5');
    IniF.WriteString('RISIKO','Zoeliakie','0,5');
    IniF.WriteString('RISIKO','Rheumatoide Arthritis','0,5');
    IniF.WriteString('RISIKO','Epilepsie','0,5');
    IniF.WriteString('RISIKO','Hypogonadismus','0,5');
    IniF.WriteString('RISIKO','Depression','0,5');
    IniF.WriteString('RISIKO','Lange PPI-Einnahme','0,5');
    IniF.WriteString('RISIKO','Glitazone','0,5');
    IniF.WriteString('RISIKO','RR-Medikation','0,5');
    IniF.WriteString('RISIKO','Antidepressiva','0,5');
    IniF.WriteString('RISIKO','Antiepileptika','0,5');
    IniF.WriteString('RISIKO','Sedierende Medikation','0,5');
    IniF.WriteString('RISIKO','Aromatasehemmer','0,5');
    IniF.WriteString('RISIKO','Antiandrogene','0,5');
    IniF.WriteInteger('FrmMainPos','Left',0);
    IniF.WriteInteger('FrmMainPos','Top',0);
    IniF.WriteInteger('FrmShowArchivPos','Left',0);
    IniF.WriteInteger('FrmShowArchivPos','Top',0);
    IniF.WriteInteger('FrmOCShowRPos','Left',0);
    IniF.WriteInteger('FrmOCShowRPos','Top',0);
    IniF.WriteInteger('FrmIniEditPos','Left',0);
    IniF.WriteInteger('FrmIniEditPos','Top',0);
    IniF.WriteString('DB','dbPfad','');
    IniF.WriteString('DB','dbName','');
    IniF.WriteString('Locale','Lang','DE');
    IniF.UpdateFile;
  except
    ShowMessage('Fehler bei Erstellung der Konfigurationsdatei.'+#10#13+
                'Bitte prüfen Sie die ob Schreibrechte für das Verzeichnis: '+
                IniPfad);
  end;
end;


end.

