unit Main;

{$mode objfpc}{$H+}

interface

uses
  SysUtils,Forms,Dialogs,variants,ComCtrls,ExtCtrls,StdCtrls,
  Menus,LCLType,MouseAndKeyInput,Controls,Classes,IniFiles,Types,strutils,
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF UseCThreads}{$ENDIF UNIX}
  {$ifdef mswindows}
  Version,windows,
  {$endif mswindows}
  {$ifdef debug}
  heaptrc,
  {$endif debug}
  IniEdit,FileUtil,DefaultTranslator,LResources;

type

  { TFrmMain }

  TFrmMain = class(TForm)
    Hauptmenu: TMainMenu;
    MenItIniEdit: TMenuItem;
    MenuKonfig: TMenuItem;
    SubLblName: TBoundLabel;
//  ***** STARTFUNKTIONEN - ANFANG **********
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
//  ***** STARTFUNKTIONEN - ENDE  **********

//  ***** Menüfunktionen - Start *****
    procedure MenItIniEditClick(Sender: TObject);
//  ***** Menüfunktionen - Ende *****


  private
    { private declarations }
  public
    { public declarations }
  end;

var
  FrmMain: TFrmMain;
  IniF:TIniFile=NIL;
  Lang,IniPfad:String;

implementation

{$R *.lfm}

{ TFrmMain }

// ***** STARTFUNKTIONEN - ANFANG *****

procedure TFrmMain.FormCreate(Sender: TObject);
var
  DatumAktuell: TDate;
  TagAktuell, MonatAktuell, JahrAktuell: word;
begin
  {$ifdef debug}
  useheaptrace:=true;         //enable report
  if FileExists('heap.trc') then DeleteFile('heap.trc');
    SetHeapTraceOutput('heap.trc');
  GlobalSkipIfNoLeaks:=true;  //heaptrace
  HaltOnError := false;       //heaptrace
  {$endif debug}
  if (IniPfad='') then IniPfad:=ExtractFilePath(Application.ExeName);
  IniF:=TIniFile.Create(IniPfad+'ORC'+ext);
  //FrmMain.Show;
  {$ifdef windows}
  FrmMain.Caption:='IniChk'+'                      Version: '+GetVersionInfo;
  {$endif windows}
  if (FileSize(IniPfad+'ORC'+ext)=-1) then FrmIniEdit.MakeIniFile;
  IniF.UpdateFile;
  Lang:=IniF.ReadString('Locale','Lang','');
  FrmMain.Left:=IniF.ReadInteger('FrmMainPos','Left',0);
  FrmMain.Top:=IniF.ReadInteger('FrmMainPos','Top',0);
end;

procedure TFrmMain.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  IniF.WriteInteger('FrmMainPos','Left',Left);
  IniF.WriteInteger('FrmMainPos','Top',Top);
  IniF.WriteString('Locale','Lang',Lang);
  IniF.UpdateFile;
  FrmIniEdit.ValEdIni.Free;
  iniF.Free;
end;

// ***** STARTFUNKTIONEN - ENDE *****

// ***** Allgemeine Funktionen *****

//Meüpunkte

procedure TFrmMain.MenItIniEditClick(Sender: TObject);
begin
  FrmIniEdit.Show;
  //FrmMain.Hide;
end;


end.

